Ipelib: ipe::CurveSegment Class Reference

Ipelib

- Main Page
- Modules
- Classes

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Friends

# ipe::CurveSegment Class Reference
Ipe Geometry

A segment on an SubPath. More...

`#include <ipeshape.h>`

List of all members.

## Public Types

- enum Type {
  EArc, ESegment, EQuad, EBezier,
  ESpline
  }

## Public Member Functions

- Type type () const
- int countCP () const
- Vector cp (int i) const
- Vector last () const
- Matrix matrix () const
- Bezier bezier () const
- Arc arc () const
- void beziers (std::vector< Bezier > &bez) const
- void draw (Painter &painter) const
- void addToBBox (Rect &box, const Matrix &m, bool cp) const
- double distance (const Vector &v, const Matrix &m, double bound) const
- void snapVtx (const Vector &mouse, const Matrix &m, Vector &pos, double &bound) const
- void snapBnd (const Vector &mouse, const Matrix &m, Vector &pos, double &bound) const

## Friends

- class Curve

## Detailed Description

A segment on an SubPath.

A segment is either an elliptic arc, a straight segment, a quadratic Bezier spline, a cubic Bezier spline, or a B-spline curve, depending on its type(). This is a lightweight object, created on the fly by Curve::segment(). There is no public constructor, so the only way to create such an object is through that method.

The type() is one of the following:

- `ESegment:` the segment has two control points, and represents a line segment.

- `EQuad:` a quadratic Bezier spline with three control points.

- `EBezier:` a cubic Bezier spline with four control points.

- `ESpline:` a B-spline curve with n control points. The first and last control point's knot value is repeated three times, so the curve begins and ends in these points.

- `EArc:` an elliptic arc, with begin and end point. The supporting ellipse is defined by the matrix(), it is the image under the affine transformation matrix() of the unit circle. matrix() is such that its inverse transforms both start and end position to points (nearly) on the unit circle. The arc is the image of the positively (counter-clockwise) directed arc from the pre-image of the start position to the pre-image of the end position. Whether this is a positively or negatively oriented arc in user space depends on the matrix.

## Member Enumeration Documentation

enum ipe::CurveSegment::Type

Enumerator:

  EArc |
  ESegment |
  EQuad |
  EBezier |
  ESpline |

## Member Function Documentation

Type ipe::CurveSegment::type | ( |  | ) | const`[inline]`

Type of segment.

int ipe::CurveSegment::countCP | ( |  | ) | const`[inline]`

Number of control points.

Vector ipe::CurveSegment::cp | ( | int | i | ) | const`[inline]`

Return control point.

Vector ipe::CurveSegment::last | ( |  | ) | const`[inline]`

Return last control point.

Matrix ipe::CurveSegment::matrix | ( |  | ) | const`[inline]`

Matrix (if Type() == EArc).

Bezier CurveSegment::bezier | ( |  | ) | const

Return segment as Bezier.

Panics if segment is not a quadratic or cubic Bezier spline.

Arc CurveSegment::arc | ( |  | ) | const

Return segment as Arc.

Panics if segment is not an arc.

void CurveSegment::beziers | ( | std::vector< Bezier > & | bez | ) | const

Convert B-spline to a sequence of Bezier splines.

void CurveSegment::draw | ( | Painter & | painter | ) | const

Draw the segment.

Current position of the painter is already on first control point.

void CurveSegment::addToBBox | ( | Rect & | box,
|  | const Matrix & | m,
|  | bool | cpf
| ) |  | const

Add segment to bounding box.

Does not assume that first control point has already been added.

If cpf is true, then control points of splines, Bezier curves, and the center of arcs are included in the bbox (so that snapping can find them). Otherwise, a tight bounding box for the geometric object itself is computed.

double CurveSegment::distance | ( | const Vector & | v,
|  | const Matrix & | m,
|  | double | bound
| ) |  | const

Return distance to the segment.

void CurveSegment::snapVtx | ( | const Vector & | mouse,
|  | const Matrix & | m,
|  | Vector & | pos,
|  | double & | bound
| ) |  | const

Snap to vertex of the segment.

The method assumes that the first control point has already been tested.

void CurveSegment::snapBnd | ( | const Vector & | mouse,
|  | const Matrix & | m,
|  | Vector & | pos,
|  | double & | bound
| ) |  | const

## Friends And Related Function Documentation

friend class Curve`[friend]`

The documentation for this class was generated from the following files:

- ipeshape.h
- ipeshape.cpp